Index: /NEMO/branches/2019/dev_r11943_MERGE_2019/src/OCE/do_loop_substitute.h90
===================================================================
--- /NEMO/branches/2019/dev_r11943_MERGE_2019/src/OCE/do_loop_substitute.h90	(revision 12340)
+++ /NEMO/branches/2019/dev_r11943_MERGE_2019/src/OCE/do_loop_substitute.h90	(revision 12341)
@@ -1,4 +1,8 @@
 #ifdef show_comments
 ! These comments are not intended to be retained during preprocessing; i.e. do not define "show_comments"
+!!----------------------------------------------------------------------
+!! NEMO/OCE 4.0 , NEMO Consortium (2018)
+!! Software governed by the CeCILL license (see ./LICENSE)
+!!----------------------------------------------------------------------
 ! This header file contains preprocessor definitions and macros used in the do-loop substitutions introduced
 ! between version 4.0 and 4.2. The primary aim of these macros is to assist in future applications of tiling
@@ -10,6 +14,6 @@
 !   DO jj = ....                           DO jj = ...
 !      DO ji = ....                           DO ji = ...
-!      .                   OR                 .  
-!      .                                      .
+!         .                   OR                 .  
+!         .                                      .
 !     END DO                                  END DO
 !   END DO                                 END DO
@@ -31,7 +35,7 @@
 !   DO jj = 2, jpj
 !      DO ji = 1, jpim1
-!      .
-!      .
-!     END DO
+!         .
+!         .
+!      END DO
 !   END DO
 !
@@ -39,9 +43,9 @@
 !
 !   DO_2D_01_10
-!   .
-!   .
+!      .
+!      .
 !   END_2D
 ! 
-! similar conventions apply to the 3D loops macros although jk loop limits are retained through macro arguments and are not restricted. This
+! similar conventions apply to the 3D loops macros. jk loop limits are retained through macro arguments and are not restricted. This
 ! includes the possibility of strides for which an extra set of DO_3DS macros are defined.
 !
@@ -49,50 +53,50 @@
 !
 #endif
-#define kIs 2
-#define kJs 2
-#define kIsm1 1
-#define kJsm1 1
+#define kIs     2
+#define kJs     2
+#define kIsm1   1
+#define kJsm1   1
 
-#define kIe jpim1
-#define kJe jpjm1
-#define kIep1 jpi
-#define kJep1 jpj
+#define kIe     jpim1
+#define kJe     jpjm1
+#define kIep1   jpi
+#define kJep1   jpj
 
-#define DO_2D_00_00 DO jj = kJs, kJe     ; DO ji = kIs, kIe
-#define DO_2D_00_01 DO jj = kJs, kJe     ; DO ji = kIs, kIep1
-#define DO_2D_00_10 DO jj = kJs, kJe     ; DO ji = kIsm1, kIe
-#define DO_2D_00_11 DO jj = kJs, kJe     ; DO ji = kIsm1, kIep1
+#define DO_2D_00_00   DO jj = kJs, kJe   ;   DO ji = kIs, kIe
+#define DO_2D_00_01   DO jj = kJs, kJe   ;   DO ji = kIs, kIep1
+#define DO_2D_00_10   DO jj = kJs, kJe   ;   DO ji = kIsm1, kIe
+#define DO_2D_00_11   DO jj = kJs, kJe   ;   DO ji = kIsm1, kIep1
  
-#define DO_2D_01_00 DO jj = kJs, kJep1   ; DO ji = kIs, kIe
-#define DO_2D_01_01 DO jj = kJs, kJep1   ; DO ji = kIs, kIep1
-#define DO_2D_01_10 DO jj = kJs, kJep1   ; DO ji = kIsm1, kIe
-#define DO_2D_01_11 DO jj = kJs, kJep1   ; DO ji = kIsm1, kIep1
+#define DO_2D_01_00   DO jj = kJs, kJep1   ;   DO ji = kIs, kIe
+#define DO_2D_01_01   DO jj = kJs, kJep1   ;   DO ji = kIs, kIep1
+#define DO_2D_01_10   DO jj = kJs, kJep1   ;   DO ji = kIsm1, kIe
+#define DO_2D_01_11   DO jj = kJs, kJep1   ;   DO ji = kIsm1, kIep1
  
-#define DO_2D_10_00 DO jj = kJsm1, kJe   ; DO ji = kIs, kIe
-#define DO_2D_10_10 DO jj = kJsm1, kJe   ; DO ji = kIsm1, kIe
-#define DO_2D_10_11 DO jj = kJsm1, kJe   ; DO ji = kIsm1, kIep1
+#define DO_2D_10_00   DO jj = kJsm1, kJe   ;   DO ji = kIs, kIe
+#define DO_2D_10_10   DO jj = kJsm1, kJe   ;   DO ji = kIsm1, kIe
+#define DO_2D_10_11   DO jj = kJsm1, kJe   ;   DO ji = kIsm1, kIep1
  
-#define DO_2D_11_00 DO jj = kJsm1, kJep1 ; DO ji = kIs, kIe
-#define DO_2D_11_01 DO jj = kJsm1, kJep1 ; DO ji = kIs, kIep1
-#define DO_2D_11_10 DO jj = kJsm1, kJep1 ; DO ji = kIsm1, kIe
-#define DO_2D_11_11 DO jj = kJsm1, kJep1 ; DO ji = kIsm1, kIep1
+#define DO_2D_11_00   DO jj = kJsm1, kJep1   ;   DO ji = kIs, kIe
+#define DO_2D_11_01   DO jj = kJsm1, kJep1   ;   DO ji = kIs, kIep1
+#define DO_2D_11_10   DO jj = kJsm1, kJep1   ;   DO ji = kIsm1, kIe
+#define DO_2D_11_11   DO jj = kJsm1, kJep1   ;   DO ji = kIsm1, kIep1
 
 
-#define DO_3D_00_00(ks,ke) DO jk = ks, ke ; DO_2D_00_00
-#define DO_3D_00_10(ks,ke) DO jk = ks, ke ; DO_2D_00_10
+#define DO_3D_00_00(ks,ke)   DO jk = ks, ke   ;   DO_2D_00_00
+#define DO_3D_00_10(ks,ke)   DO jk = ks, ke   ;   DO_2D_00_10
  
-#define DO_3D_01_01(ks,ke) DO jk = ks, ke ; DO_2D_01_01
+#define DO_3D_01_01(ks,ke)   DO jk = ks, ke   ;   DO_2D_01_01
  
-#define DO_3D_10_00(ks,ke) DO jk = ks, ke ; DO_2D_10_00
-#define DO_3D_10_10(ks,ke) DO jk = ks, ke ; DO_2D_10_10
-#define DO_3D_10_11(ks,ke) DO jk = ks, ke ; DO_2D_10_11
+#define DO_3D_10_00(ks,ke)   DO jk = ks, ke   ;   DO_2D_10_00
+#define DO_3D_10_10(ks,ke)   DO jk = ks, ke   ;   DO_2D_10_10
+#define DO_3D_10_11(ks,ke)   DO jk = ks, ke   ;   DO_2D_10_11
  
-#define DO_3D_11_11(ks,ke) DO jk = ks, ke ; DO_2D_11_11
+#define DO_3D_11_11(ks,ke)   DO jk = ks, ke   ;   DO_2D_11_11
 
-#define DO_3DS_00_00(ks,ke,ki) DO jk = ks, ke, ki ; DO_2D_00_00
-#define DO_3DS_01_01(ks,ke,ki) DO jk = ks, ke, ki ; DO_2D_01_01
-#define DO_3DS_10_10(ks,ke,ki) DO jk = ks, ke, ki ; DO_2D_10_10
-#define DO_3DS_11_11(ks,ke,ki) DO jk = ks, ke, ki ; DO_2D_11_11
+#define DO_3DS_00_00(ks,ke,ki)   DO jk = ks, ke, ki   ;   DO_2D_00_00
+#define DO_3DS_01_01(ks,ke,ki)   DO jk = ks, ke, ki   ;   DO_2D_01_01
+#define DO_3DS_10_10(ks,ke,ki)   DO jk = ks, ke, ki   ;   DO_2D_10_10
+#define DO_3DS_11_11(ks,ke,ki)   DO jk = ks, ke, ki   ;   DO_2D_11_11
 
-#define END_2D END DO ; END DO
-#define END_3D END DO ; END DO ; END DO
+#define END_2D   END DO   ;   END DO
+#define END_3D   END DO   ;   END DO   ;   END DO