Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/cfgs/SHARED/namelist_pisces_ref
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/cfgs/SHARED/namelist_pisces_ref	(revision 12347)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/cfgs/SHARED/namelist_pisces_ref	(revision 12348)
@@ -56,6 +56,6 @@
    lthet      =  1.0      ! Proportional loss of ligands due to Fe uptake 
 !                         !  ln_p5z enabled
-   no3rat3    =  0.182    ! N/C ratio in zooplankton
-   po4rat3    =  0.0094   ! P/C ratio in zooplankton
+   no3rat3    =  0.151    ! N/C ratio in zooplankton
+   po4rat3    =  0.00943  ! P/C ratio in zooplankton
 /
 !-----------------------------------------------------------------------
@@ -75,5 +75,5 @@
    xsizern    =  3.0      ! Size ratio for nanophytoplankton
    xsizerd    =  3.0      ! Size ratio for diatoms
-   xksi1      =  2.E-6    ! half saturation constant for Si uptake
+   xksi1      =  4.E-6    ! half saturation constant for Si uptake
    xksi2      =  20E-6    ! half saturation constant for Si/C
    xkdoc      =  417.E-6  ! half-saturation constant of DOC remineralization
@@ -87,15 +87,15 @@
 !-----------------------------------------------------------------------
    concnno3   =  3e-6     ! Nitrate half saturation of nanophytoplankton
-   concpno3   =  1e-6
-   concdno3   =  4E-6     ! Phosphate half saturation for diatoms
-   concnnh4   =  1.5E-6   ! NH4 half saturation for phyto
-   concpnh4   =  4E-7
-   concdnh4   =  2E-6     ! NH4 half saturation for diatoms
+   concpno3   =  8e-7
+   concdno3   =  5E-6     ! Phosphate half saturation for diatoms
+   concnnh4   =  1E-6     ! NH4 half saturation for phyto
+   concpnh4   =  2.3E-7
+   concdnh4   =  1.7E-6   ! NH4 half saturation for diatoms
    concnpo4   =  3E-6     ! PO4 half saturation for phyto
-   concppo4   =  1.5E-6
-   concdpo4   =  4E-6     ! PO4 half saturation for diatoms
+   concppo4   =  8E-7
+   concdpo4   =  5E-6     ! PO4 half saturation for diatoms
    concnfer   =  3E-9   ! Iron half saturation for phyto
-   concpfer   =  1.5E-9
-   concdfer   =  4E-9   ! Iron half saturation for diatoms
+   concpfer   =  8E-10
+   concdfer   =  5E-9   ! Iron half saturation for diatoms
    concbfe    =  1.E-11   ! Half-saturation for Fe limitation of Bacteria
    concbnh4   =  1.E-7    ! NH4 half saturation for phyto
@@ -104,12 +104,12 @@
    xsizedia   =  1.E-6    ! Minimum size criteria for diatoms
    xsizephy   =  1.E-6    ! Minimum size criteria for phyto
-   xsizepic   =  1.E-6
-   xsizern    =  1.0      ! Size ratio for nanophytoplankton
-   xsizerp    =  1.0
+   xsizepic   =  5.E-7    ! Minimum size criteria for picophyto
+   xsizern    =  3.0      ! Size ratio for nanophytoplankton
+   xsizerp    =  2.0      ! Size ratio for picophytoplankton
    xsizerd    =  4.0      ! Size ratio for diatoms
-   xksi1      =  2.E-6    ! half saturation constant for Si uptake
+   xksi1      =  8.E-6    ! half saturation constant for Si uptake
    xksi2      =  20E-6  ! half saturation constant for Si/C
    xkdoc      =  417.E-6  ! half-saturation constant of DOC remineralization
-   caco3r     =  0.35     ! mean rain ratio
+   caco3r     =  0.5      ! mean rain ratio
    oxymin     =  1.E-6    ! Half-saturation constant for anoxia
 /
@@ -120,19 +120,19 @@
    qfpopt     =  7.E-6    ! Optimal Fe quota of picophyto
    qfdopt     =  7.E-6    ! Optimal quota of diatoms
-   qnnmin     =  0.29     ! Minimal N quota for nano
-   qnnmax     =  1.39     ! Maximal N quota for nano
-   qpnmin     =  0.28     ! Minimal P quota for nano
-   qpnmax     =  1.06     ! Maximal P quota for nano
-   qnpmin     =  0.42     ! Minimal N quota for pico
-   qnpmax     =  1.39     ! Maximal N quota for pico
-   qppmin     =  0.25     ! Minimal P quota for pico
-   qppmax     =  0.7      ! Maximal P quota for pico
-   qndmin     =  0.25     ! Minimal N quota for diatoms
-   qndmax     =  1.39     ! Maximal N quota for diatoms
-   qpdmin     =  0.29     ! Minimal P quota for diatoms
-   qpdmax     =  1.32     ! Maximal P quota for diatoms
-   qfnmax     =  40E-6    ! Maximal Fe quota for nano
-   qfpmax     =  40E-6    ! Maximal Fe quota for pico
-   qfdmax     =  40E-6    ! Maximal Fe quota for diatoms
+   qnnmin     =  0.61     ! Minimal N quota for nano
+   qnnmax     =  1.25     ! Maximal N quota for nano
+   qpnmin     =  0.24     ! Minimal P quota for nano
+   qpnmax     =  1.35     ! Maximal P quota for nano
+   qnpmin     =  1.04     ! Minimal N quota for pico
+   qnpmax     =  1.525    ! Maximal N quota for pico
+   qppmin     =  0.19     ! Minimal P quota for pico
+   qppmax     =  1.15     ! Maximal P quota for pico
+   qndmin     =  0.53     ! Minimal N quota for diatoms
+   qndmax     =  1.25     ! Maximal N quota for diatoms
+   qpdmin     =  0.24     ! Minimal P quota for diatoms
+   qpdmax     =  1.525    ! Maximal P quota for diatoms
+   qfnmax     =  80E-6    ! Maximal Fe quota for nano
+   qfpmax     =  80E-6    ! Maximal Fe quota for pico
+   qfdmax     =  80E-6    ! Maximal Fe quota for diatoms
 /
 !-----------------------------------------------------------------------
@@ -160,12 +160,12 @@
    fecnm      =  40E-6    ! Maximum Fe/C in nanophytoplankton
    fecdm      =  40E-6    ! Maximum Fe/C in diatoms
-   grosip     =  0.159    ! mean Si/C ratio
+   grosip     =  0.13     ! mean Si/C ratio
 /
 !-----------------------------------------------------------------------
 &namp5zprod    !   parameters for phytoplankton growth for PISCES quota- ln_p5z
 !-----------------------------------------------------------------------
-   pislopen   =  3.       ! P-I slope
-   pislopep   =  3.       ! P-I slope for picophytoplankton
-   pisloped   =  3.       ! P-I slope  for diatoms
+   pislopen   =  4.       ! P-I slope of nanophytoplankton
+   pislopep   =  4.       ! P-I slope for picophytoplankton
+   pisloped   =  4.       ! P-I slope  for diatoms
    excretn    =  0.05     ! excretion ratio of phytoplankton
    excretp    =  0.05     ! excretion ratio of picophytoplankton
@@ -173,9 +173,9 @@
    xadap      =  0.       ! Adaptation factor to low light
    bresp      =  0.02     ! Basal respiration rate
-   thetannm   =  0.25     ! Maximum Chl/N in nanophytoplankton
-   thetanpm   =  0.25     ! Maximum Chl/N in picophytoplankton
-   thetandm   =  0.3      ! Maximum Chl/N in diatoms
+   thetannm   =  0.3      ! Maximum Chl/N in nanophytoplankton
+   thetanpm   =  0.3      ! Maximum Chl/N in picophytoplankton
+   thetandm   =  0.4      ! Maximum Chl/N in diatoms
    chlcmin    =  0.004    ! Minimum Chl/c in phytoplankton
-   grosip     =  0.131    ! mean Si/C ratio
+   grosip     =  0.11     ! mean Si/C ratio
 /
 !-----------------------------------------------------------------------
@@ -194,8 +194,8 @@
    wchlp      =  0.01     ! quadratic mortality of picophytoplankton
    wchld      =  0.01     ! maximum quadratic mortality of diatoms
-   wchldm     =  0.02     ! maximum quadratic mortality of diatoms
+   wchldm     =  0.03     ! maximum quadratic mortality of diatoms
    mpratn     =  0.01     ! nanophytoplankton mortality rate
    mpratp     =  0.01     ! picophytoplankton mortality rate
-   mprat2     =  0.01     ! Diatoms mortality rate
+   mpratd     =  0.01     ! Diatoms mortality rate
 /
 !-----------------------------------------------------------------------
@@ -226,12 +226,12 @@
 !-----------------------------------------------------------------------
    part2      =  0.75     ! part of calcite not dissolved in mesozoo guts
-   grazrat2   =  0.85     ! maximal mesozoo grazing rate
+   grazrat2   =  0.75     ! maximal mesozoo grazing rate
    bmetexc2   =  .true.   ! Metabolic use of excess carbon 
    resrat2    =  0.005    ! exsudation rate of mesozooplankton
-   mzrat2     =  0.02     ! mesozooplankton mortality rate
+   mzrat2     =  0.03     ! mesozooplankton mortality rate
    xpref2d    =  1.       ! zoo preference for phyto
-   xpref2p    =  1.       ! zoo preference for POC
+   xpref2n    =  0.3      ! zoo preference for nano
    xpref2z    =  1.       ! zoo preference for zoo
-   xpref2m    =  0.2      ! meso preference for zoo
+   xpref2m    =  0.1      ! meso preference for zoo
    xpref2c    =  0.3      ! zoo preference for poc
    xthresh2zoo = 1E-8     ! zoo feeding threshold for mesozooplankton
@@ -243,5 +243,5 @@
    xkgraz2     =  20.E-6   ! half sturation constant for meso grazing
    epsher2     =  0.5      ! Efficicency of Mesozoo growth
-   epsher2min  =  0.2     ! Minimum efficiency of mesozoo growth
+   epsher2min  =  0.5     ! Minimum efficiency of mesozoo growth
    ssigma2     =  0.5     ! Fraction excreted as semi-labile DOM
    srespir2    =  0.2     ! Active respiration
@@ -275,13 +275,13 @@
 !-----------------------------------------------------------------------
    part       =  0.5      ! part of calcite not dissolved in microzoo gutsa
-   grazrat    =  2.75     ! maximal zoo grazing rate
+   grazrat    =  3.0      ! maximal zoo grazing rate
    bmetexc    =  .true.   ! Metabolic use of excess carbon
    resrat     =  0.03     ! exsudation rate of zooplankton
-   mzrat      =  0.005    ! zooplankton mortality rate
+   mzrat      =  0.004    ! zooplankton mortality rate
    xprefc     =  0.1      ! Microzoo preference for POM
-   xprefn     =  1.       ! Microzoo preference for Nanophyto
-   xprefp     =  1.6      ! Microzoo preference for picophyto
-   xprefd     =  1.0      ! Microzoo preference for Diatoms
-   xprefz     =  0.3      ! Microzoo preference for microzooplankton
+   xprefn     =  1.0      ! Microzoo preference for Nanophyto
+   xprefp     =  1.0      ! Microzoo preference for picophyto
+   xprefd     =  0.8      ! Microzoo preference for Diatoms
+   xprefz     =  0.1      ! Microzoo preference for microzooplankton
    xthreshdia =  1.E-8    ! Diatoms feeding threshold for microzooplankton
    xthreshphy =  1.E-8    ! Nanophyto feeding threshold for microzooplankton
@@ -292,5 +292,5 @@
    xkgraz     =  20.E-6   ! half sturation constant for grazing
    epsher     =  0.5      ! Efficiency of microzoo growth
-   epshermin  =  0.2      ! Minimum efficiency of microzoo growth
+   epshermin  =  0.5      ! Minimum efficiency of microzoo growth
    ssigma     =  0.5      ! Fraction excreted as semi-labile DOM
    srespir    =  0.2      ! Active respiration
@@ -320,7 +320,7 @@
 !                         ! ln_p5z
    xremikc   =  0.25      ! remineralization rate of DOC
-   xremikn   =  0.35      ! remineralization rate of DON
+   xremikn   =  0.3       ! remineralization rate of DON
    xremikp   =  0.4       ! remineralization rate of DOP
-!   feratb    =  20E-6     ! Bacterial Fe/C ratio
+!   feratb    =  40E-6     ! Bacterial Fe/C ratio
 !   xkferb    =  3E-10     ! Half-saturation constant for bact. Fe/C
 /
@@ -332,7 +332,7 @@
    rshape    =  1.0       ! Shape of the gamma function
 !                         ! ln_p5z
-   xremipc   =  0.02      ! remineralisation rate of POC
-   xremipn   =  0.025     ! remineralisation rate of PON
-   xremipp   =  0.03      ! remineralisation rate of POP
+   xremipc   =  0.028     ! remineralisation rate of POC
+   xremipn   =  0.03      ! remineralisation rate of PON
+   xremipp   =  0.035     ! remineralisation rate of POP
 /
 !-----------------------------------------------------------------------